/*
 * memory.h -- memory manager
 */


#ifndef _MEMORY_H_
#define _MEMORY_H_


#define LOG1			0
#define LOG2			1
#define LOG4			2
#define LOG8			3
#define LOG16			4
#define LOG32			5
#define LOG64			6
#define LOG128			7
#define LOG256			8
#define LOG512			9
#define LOG1K			10
#define LOG2K			11
#define LOG4K			12
#define LOG8K			13
#define LOG16K			14
#define LOG32K			15
#define LOG64K			16
#define LOG128K			17
#define LOG256K			18
#define LOG512K			19
#define LOG1M			20
#define LOG2M			21
#define LOG4M			22
#define LOG8M			23
#define LOG16M			24

#define MEMORY_STATIC		0
#define MEMORY_DYNAMIC		1
#define MEMORY_CLUSTERS		2


void memoryInit(int logMaxSize, int numClusters);
void memoryExit(void);
void *memoryAllocate(Uint size, int cluster);
void memoryFree(void *p);
void memoryFreeCluster(int cluster);


#endif /* _MEMORY_H_ */
